Subject: bug#23504: git 2.7.4 fails to clone repositories over HTTPS sources

From: [email-masked] (Ludovic Courtès)
Date: Tue, 10 May 2016 15:38:57 +0200

Dennis Mungai <[email-masked]> skribis:

> I'm using git 2.7.4 from a guix profile, and here is my current environment:
>
> guix package -p ~/opt/guix-build-system --search-paths
> warning: failed to install locale: Invalid argument
> export PATH="/home/lin/opt/guix-build-system/bin:/home/lin/opt/guix-build-system/sbin"
> export XDG_DATA_DIRS="/home/lin/opt/guix-build-system/share"
> export GUIX_GTK3_PATH="/home/lin/opt/guix-build-system/lib/gtk-3.0"
> export INFOPATH="/home/lin/opt/guix-build-system/share/info"
> export PKG_CONFIG_PATH="/home/lin/opt/guix-build-system/lib/pkgconfig"
> export GUILE_LOAD_COMPILED_PATH="/home/lin/opt/guix-build-system/lib/guile/2.0/ccache"
> export C_INCLUDE_PATH="/home/lin/opt/guix-build-system/include"
> export CPLUS_INCLUDE_PATH="/home/lin/opt/guix-build-system/include"
> export LIBRARY_PATH="/home/lin/opt/guix-build-system/lib"
> export ACLOCAL_PATH="/home/lin/opt/guix-build-system/share/aclocal"
>
> which env returns:
>
> which env
> /home/lin/opt/guix-build-system/bin/env
>
> Now, with git clone example over HTTPS:
>
> git clone --branch gn-latest https://github.com/genenetwork/guix-bioinformatics
> Cloning into 'guix-bioinformatics'...
> fatal: unable to access
> 'https://github.com/genenetwork/guix-bioinformatics/': server
> certificate verification failed. CAfile: none CRLfile: none
>
> The system git does not present such an error.
>
> What could be wrong with my setup? Missing certificates?
>
> At the moment, I've installed the nss-certs package hoping it would be
> a workaround as these are Mozilla certs, but to no avail.

I think you also need to set the ‘GIT_SSL_CAINFO’ environment variable.
For instance:

     $ guix package -i nss-certs
     $ export SSL_CERT_DIR="$HOME/.guix-profile/etc/ssl/certs"
     $ export SSL_CERT_FILE="$HOME/.guix-profile/etc/ssl/certs/ca-certificates.crt"
     $ export GIT_SSL_CAINFO="$SSL_CERT_FILE"

Can you confirm?

Thanks,
Ludo’.